%{
/*
 * FILE: $Source: /u/chestnut/ezk/kitot/advanced-os/2/RCS/esh_parser.y,v $
 * HEADER: $Id: esh_parser.y,v 1.11 1992/02/11 13:56:39 ezk Exp ezk $
 * REVISION HISTORY:
 * $Log: esh_parser.y,v $
 * Revision 1.11  1992/02/11  13:56:39  ezk
 * FINAL VERSION (unless I get an extension...)
 *
 * Revision 1.10  1992/02/10  00:30:08  ezk
 * bg and & work now.  bug fixes so that status reported in "jobs" cmd
 * is correct, and also each time you hit newline.
 *
 * Revision 1.9  1992/02/09  19:01:19  ezk
 * more work on job control. can bg and stop process. some status gets
 * reported but not perfect yet.
 *
 * Revision 1.8  1992/02/09  00:22:13  ezk
 * one process in fg.  can ^C it or wait until it ends.  shell prompt
 * using PS1 if used.  can suspend a process but not bg/fg it yet.
 *
 * Revision 1.7  1992/02/07  04:53:50  ezk
 * built major jobs structures and converted code to use it.
 * basic export command.
 *
 * Revision 1.6  1992/02/06  21:50:46  ezk
 * simple variables (w/o braces) are supported and expanded, even if
 * prefeixed or postfixed by other strings or variables.
 *
 * Revision 1.5  1992/02/04  23:07:21  ezk
 * added exit command
 *
 * Revision 1.4  1992/02/04  22:34:15  ezk
 * parses & and ; correctlly with pipelines too. builds the structures.
 * no execing yet.
 *
 *
 *
 * Grammar for the shell.
 * 
 * E6118y - Advanced Operating Systems.
 * Erez Zadok.
 * Columbia U.  Spring 1992.
 */

#include "process.h"

%}

%union {
	char buf[BUFSIZ];	/* that's what they use for YYLMAX */
	int integer;
      }

%token <buf> WORD
%token <integer> PIPE, NL, AMPERSAND, SEMICOLON

%type <buf> lines, line, jobs, job, pipeline, command

%start lines

%%

lines	: line		{ each_line(); }
	| lines line	{ each_line(); }
	;

line	: NL	{ strcpy($$, ""); /* dummy action */
		}
	| jobs NL
	;

jobs	: job
	| jobs job;
	;
				/* list + control chars */
job	: pipeline AMPERSAND	{ add_stat_to_proc(jobs[cur_job].head_proc,
						   P_BG, P_NOCHANGE, 0);
				  exec_pipeline(&(jobs[cur_job].head_proc));
				}
	| pipeline SEMICOLON	{ exec_pipeline(&(jobs[cur_job].head_proc)); }
 	| pipeline NL		{ exec_pipeline(&(jobs[cur_job].head_proc)); }
	;

pipeline	: command
		| pipeline PIPE command
		;

command	: WORD	{ strcpy($$, $1);
		  init_proc($$);
		}
	| command WORD	{ /* strcpy($$, $2); */
			  add_arg_2_proc(&(jobs[cur_job].cur_proc), $2);
			}
	;

%% 
				/* END OF GRAMMAR */

yyerror(s)
     char *s;
{ char c;

  if (yychar == 0) {		/* detect if someone closed stdin ^D */
    puts("end of file!");
    exit(0);
  }
  fprintf(stderr, "%s: %s.\n", progname, s);
				/* skip until next cmd */
  while ((c = getchar()) != '\n'  &&  c != ';') ;

  if (jobs[cur_job].head_proc) {
    puts("\tfreeing...");
    free_pipeline(jobs[cur_job].head_proc);	/* free mem */
    tmp_proc = jobs[cur_job].cur_proc = jobs[cur_job].head_proc = NULL_PROC;
  }
  yyerrok;			/* restart everything again */
  yyclearin;			/* clear lookahead token */
}
